=== debian/changelog ===
webcamoid (9.2.3-1~mx23+2) mx; urgency=medium

  * Fix QML dependencies so they are Qt6, not Qt5.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 20 Nov 2024 22:56:42 -0800

webcamoid (9.2.3-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 20 Nov 2024 18:49:35 -0800

webcamoid (9.2.3-1) unstable; urgency=medium

  * New upstream version
  * Switch to Qt6
  * Cannot reproduce MultiSink_ffmpeg plugin crash (closes: #1053808)
  * Redundant report of ffmpeg 7 issue, see 1072457 below (closes: #1080481)
  * Calls to pkexec should now work (closes: #1006881)
  * Release addresses select/add filter scrollbox problem (closes: #1006881)
    and filter ui errors scrollbox issue (closes: #954839)

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 07 Nov 2024 17:08:06 +0000

webcamoid (9.1.1-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Cherry-pick patch to fix build with ffmpeg 7 (Closes: #1072457)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 10 Sep 2024 14:48:52 -0400
