=== debian/control ===
Source: webcamoid
Section: video
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gstreamer1.0-plugins-base,
               gstreamer1.0-plugins-good,
               libasound2-dev,
               libavcodec-dev (>= 4.0),
               libavdevice-dev (>= 4.0),
               libavformat-dev (>= 4.0),
               libavutil-dev (>= 4.0),
               libgl-dev,
               libgstreamer-plugins-base1.0-dev,
               libgstreamer1.0-0,
               libjack-dev,
               libkmod-dev,
               libpipewire-0.3-dev,
               libpipewire-0.3-modules,
               libpulse-dev,
               libqt6opengl6-dev,
               libqt6svg6-dev,
               libsdl2-dev,
               libswresample-dev,
               libswscale-dev,
               libusb-1.0-0-dev,
               libusb-dev,
               libuvc-dev,
               libv4l-dev,
               libvlc-dev,
               libvlccore-dev,
               libvulkan-dev,
               libwebpdemux2,
               libxext-dev,
               libxfixes-dev,
               linux-libc-dev,
               pkgconf,
               portaudio19-dev,
               qml6-module-qt-labs-folderlistmodel,
               qml6-module-qt-labs-platform,
               qml6-module-qt-labs-settings,
               qml6-module-qtcore,
               qml6-module-qtmultimedia,
               qml6-module-qtqml,
               qml6-module-qtqml-models,
               qml6-module-qtqml-workerscript,
               qml6-module-qtquick-controls,
               qml6-module-qtquick-dialogs,
               qml6-module-qtquick-layouts,
               qml6-module-qtquick-nativestyle,
               qml6-module-qtquick-shapes,
               qml6-module-qtquick-templates,
               qml6-module-qtquick-window,
               qml6-module-qtquick3d-spatialaudio,
               qml6-module-qttest,
               qml6-module-qtwayland-compositor,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-l10n-tools,
               qt6-multimedia-dev,
               qt6-quick3d-dev,
               qt6-quicktimeline-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools,
               qt6-wayland,
               vlc-plugin-base
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://webcamoid.github.io/
Vcs-Git: https://salsa.debian.org/debian/webcamoid.git
Vcs-Browser: https://salsa.debian.org/debian/webcamoid

Package: webcamoid
Architecture: linux-any
Depends: qml6-module-qt-labs-folderlistmodel,
         qml6-module-qt-labs-platform,
         qml6-module-qt-labs-settings,
         qml6-module-qtcore,
         qml6-module-qtmultimedia,
         qml6-module-qtqml,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-dialogs,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-nativestyle,
         qml6-module-qtquick-shapes,
         qml6-module-qtquick-templates,
         qml6-module-qtquick-window,
         qml6-module-qtquick3d-spatialaudio,
         qml6-module-qttest,
         qml6-module-qtwayland-compositor,
         webcamoid-data,
         webcamoid-plugins,
         ${misc:Depends},
         ${shlibs:Depends}
Description: full featured webcam capture application
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
  * Many recording formats.
  * Virtual webcam support for feeding other programs.

Package: libavkys9
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libavkys7 (<< 7.2.1+dfsg1-5~)
Replaces: libavkys7 (<< 7.2.1+dfsg1-5~)
Description: full featured webcam capture application - library
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
  * Many recording formats.
  * Virtual webcam support for feeding other programs.
 .
 This package contains the library for webcamoid.

Package: libavkys-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libavkys9 (= ${binary:Version}), ${misc:Depends}
Breaks: libavkys7 (<= 7.2.1+dfsg1-5~)
Replaces: libavkys7 (<= 7.2.1+dfsg1-5~)
Description: full featured webcam capture application - dev
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
  * Many recording formats.
  * Virtual webcam support for feeding other programs.
 .
 This package contains the development files of libavkys.

Package: webcamoid-plugins
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: qb-plugins (= 6.2.0)
Replaces: qb-plugins (= 6.2.0)
Description: full featured webcam capture application - plugins
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
  * Many recording formats.
  * Virtual webcam support for feeding other programs.
 .
 This package contains the plugins for webcamoid.

Package: webcamoid-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: icons and locale files for webcamoid
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
  * Many recording formats.
  * Virtual webcam support for feeding other programs.
 .
 This package contains the icons/locale files for webcamoid.
